Loading...
Searching...
No Matches
Sip_timestamp

## Data Structures

struct | sip_timestamp_s
| Structure for Timestamp header. More...

## Macros

#define | sip_timestamp(sip)
| Access a SIP Timestamp header structure sip_timestamp_t from sip_t.
#define | SIP_TIMESTAMP_INIT()
| Initializer for structure sip_timestamp_t.
#define | SIPTAG_TIMESTAMP(x)
| Tag list item for pointer to a Timestamp header structure sip_timestamp_t.
#define | SIPTAG_TIMESTAMP_REF(x)
| Tag list item for reference to a Timestamp header pointer.
#define | SIPTAG_TIMESTAMP_STR(s)
| Tag list item for string with Timestamp header value.
#define | SIPTAG_TIMESTAMP_STR_REF(x)
| Tag list item for reference to a Timestamp header string.

## Typedefs

typedef struct sip_timestamp_s | sip_timestamp_t
| @

## Functions

issize_t | sip_timestamp_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Timestamp header.
issize_t | sip_timestamp_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Timestamp header.
sip_timestamp_t * | sip_timestamp_init (sip_timestamp_t x[1])
| Initialize a structure sip_timestamp_t.
int | sip_is_timestamp (sip_header_t const *header)
| Test if header object is instance of sip_timestamp_t.
sip_timestamp_t * | sip_timestamp_dup (su_home_t *home, sip_timestamp_t const *hdr))
| Duplicate a list of Timestamp header header structures sip_timestamp_t.
sip_timestamp_t * | sip_timestamp_copy (su_home_t *home, sip_timestamp_t const *hdr))
| Copy a list of Timestamp header header structures sip_timestamp_t.
sip_timestamp_t * | sip_timestamp_make (su_home_t *home, char const *s))
| Make a Timestamp header structure sip_timestamp_t.
sip_timestamp_t * | sip_timestamp_format (su_home_t *home, char const *fmt,...)))
| Make a Timestamp header from formatting result.

## Variables

msg_hclass_t | sip_timestamp_class []
| Header class for Timestamp header.
tag_typedef_t | siptag_timestamp
| Tag for Timestamp header object.
tag_typedef_t | siptag_timestamp_str
| Tag for string with Timestamp header value.

## Detailed Description

## Macro Definition Documentation

## SIP_TIMESTAMP_INIT

#define SIP_TIMESTAMP_INIT | ( |  | ) |

Initializer for structure sip_timestamp_t.

A static sip_timestamp_t structure for Timestamp header must be initialized with the SIP_TIMESTAMP_INIT() macro. For instance,

sip_timestamp_t sip_timestamp = SIP_TIMESTAMP_INIT;
sip_timestamp
#define sip_timestamp(sip)
Access a SIP Timestamp header structure sip_timestamp_t from sip_t.
Definition sip_protos.h:4891
sip_timestamp_t
struct sip_timestamp_s sip_timestamp_t
@
Definition sip.h:196
SIP_TIMESTAMP_INIT
#define SIP_TIMESTAMP_INIT()
Initializer for structure sip_timestamp_t.
Definition sip_protos.h:4908

## SIPTAG_TIMESTAMP

#define SIPTAG_TIMESTAMP | ( |  | x | ) |

Tag list item for pointer to a Timestamp header structure sip_timestamp_t.

The SIPTAG_TIMESTAMP() macro is used to include a tag item with a pointer to a sip_timestamp_t structure in a tag list.

Parameters

  x | pointer to a sip_timestamp_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_TIMESTAMP_REF().

## SIPTAG_TIMESTAMP_STR

#define SIPTAG_TIMESTAMP_STR | ( |  | s | ) |

Tag list item for string with Timestamp header value.

The SIPTAG_TIMESTAMP_STR() macro is used to include a tag item with a string containing value of a sip_timestamp_t header in a tag list.

Parameters

  s | pointer to a string containing Timestamp header value, or NULL.

The string in SIPTAG_TIMESTAMP_STR() can be converted to a sip_timestamp_t header structure by giving the string s has second argument to function sip_timestamp_make().

The corresponding tag taking reference parameter is SIPTAG_TIMESTAMP_STR_REF().

## Typedef Documentation

## sip_timestamp_t

typedef struct sip_timestamp_s sip_timestamp_t

@

The Timestamp header describes when the client sent the request to the server, and it is used by the client to adjust its retransmission intervals. Its syntax is defined in RFC 3261 as follows:

Timestamp = "Timestamp" HCOLON 1*(DIGIT)
[ "." *(DIGIT) ] [ LWS delay ]
delay = *(DIGIT) [ "." *(DIGIT) ]
DIGIT
#define DIGIT
LWS
#define LWS

The parsed Timestamp header is stored in sip_timestamp_t structure.

The structure sip_timestamp_t contains representation of a SIP Timestamp header.

The sip_timestamp_t is defined as follows:

typedef struct sip_timestamp_s
{
sip_common_t ts_common[1]; // Common fragment info
sip_error_t *ts_next; // Dummy link
char const *ts_stamp; // Original timestamp
char const *ts_delay; // Delay at UAS
} sip_timestamp_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_timestamp_s
Structure for Timestamp header.
Definition sip.h:742
sip_timestamp_s::ts_stamp
char const * ts_stamp
Original timestamp.
Definition sip.h:745
sip_timestamp_s::ts_common
sip_common_t ts_common[1]
Common fragment info.
Definition sip.h:743
sip_timestamp_s::ts_delay
char const * ts_delay
Delay at UAS.
Definition sip.h:746
sip_timestamp_s::ts_next
sip_error_t * ts_next
Dummy link to next.
Definition sip.h:744

## Function Documentation

## sip_is_timestamp()

int sip_is_timestamp | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_timestamp_t.

Check if the header class is an instance of Timestamp header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header timestamp
  0 | (false) otherwise

## sip_timestamp_copy()

sip_timestamp_t * sip_timestamp_copy | ( | su_home_t * | home,
|  | sip_timestamp_t const * | hdr )

inline

Copy a list of Timestamp header header structures sip_timestamp_t.

The function sip_timestamp_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  timestamp = sip_timestamp_copy(home, sip->sip_timestamp);
  sip_timestamp_copy
  sip_timestamp_t * sip_timestamp_copy(su_home_t *home, sip_timestamp_t const *hdr))
  Copy a list of Timestamp header header structures sip_timestamp_t.
  Definition sip_protos.h:5038

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_timestamp_dup()

sip_timestamp_t * sip_timestamp_dup | ( | su_home_t * | home,
|  | sip_timestamp_t const * | hdr )

inline

Duplicate a list of Timestamp header header structures sip_timestamp_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  timestamp = sip_timestamp_dup(home, sip->sip_timestamp);
  sip_timestamp_dup
  sip_timestamp_t * sip_timestamp_dup(su_home_t *home, sip_timestamp_t const *hdr))
  Duplicate a list of Timestamp header header structures sip_timestamp_t.
  Definition sip_protos.h:4995

Returns
  A pointer to the newly duplicated sip_timestamp_t header structure, or NULL upon an error.

## sip_timestamp_format()

sip_timestamp_t * sip_timestamp_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Timestamp header from formatting result.

Make a new sip_timestamp_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_timestamp_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_timestamp_init()

sip_timestamp_t * sip_timestamp_init | ( | sip_timestamp_t | x[1] | ) |

inline

Initialize a structure sip_timestamp_t.

An sip_timestamp_t structure for Timestamp header can be initialized with the sip_timestamp_init() function/macro. For instance,

sip_timestamp_t sip_timestamp;
sip_timestamp_init(&sip_timestamp);
sip_timestamp_init
sip_timestamp_t * sip_timestamp_init(sip_timestamp_t x[1])
Initialize a structure sip_timestamp_t.
Definition sip_protos.h:4926

## sip_timestamp_make()

sip_timestamp_t * sip_timestamp_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Timestamp header structure sip_timestamp_t.

The function sip_timestamp_make() makes a new sip_timestamp_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_timestamp_t header structure, or NULL upon an error.

## Variable Documentation

## sip_timestamp_class

msg_hclass_t sip_timestamp_class[]

extern

Header class for Timestamp header.

The header class sip_timestamp_class defines how a SIP Timestamp header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_timestamp_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.